com.jnape.palatable.lambda.monoid.builtin

## Class Compose<A>

- java.lang.Object
- - com.jnape.palatable.lambda.monoid.builtin.Compose<A>

- Type Parameters:
    `A` - the future parameter type
  All Implemented Interfaces:
    Fn1<Monoid<A>,Fn1<CompletableFuture<A>,Fn1<CompletableFuture<A>,CompletableFuture<A>>>>, Fn2<Monoid<A>,CompletableFuture<A>,Fn1<CompletableFuture<A>,CompletableFuture<A>>>, Fn3<Monoid<A>,CompletableFuture<A>,CompletableFuture<A>,CompletableFuture<A>>, MonoidFactory<Monoid<A>,CompletableFuture<A>>, SemigroupFactory<Monoid<A>,CompletableFuture<A>>, Applicative<Fn1<CompletableFuture<A>,Fn1<CompletableFuture<A>,CompletableFuture<A>>>,Fn1<Monoid<A>,?>>, Cartesian<Monoid<A>,Fn1<CompletableFuture<A>,Fn1<CompletableFuture<A>,CompletableFuture<A>>>,Fn1<?,?>>, Cocartesian<Monoid<A>,Fn1<CompletableFuture<A>,Fn1<CompletableFuture<A>,CompletableFuture<A>>>,Fn1<?,?>>, Contravariant<Monoid<A>,Profunctor<?,Fn1<CompletableFuture<A>,Fn1<CompletableFuture<A>,CompletableFuture<A>>>,Fn1<?,?>>>, Functor<Fn1<CompletableFuture<A>,Fn1<CompletableFuture<A>,CompletableFuture<A>>>,Fn1<Monoid<A>,?>>, Profunctor<Monoid<A>,Fn1<CompletableFuture<A>,Fn1<CompletableFuture<A>,CompletableFuture<A>>>,Fn1<?,?>>, Monad<Fn1<CompletableFuture<A>,Fn1<CompletableFuture<A>,CompletableFuture<A>>>,Fn1<Monoid<A>,?>>, MonadReader<Monoid<A>,Fn1<CompletableFuture<A>,Fn1<CompletableFuture<A>,CompletableFuture<A>>>,Fn1<Monoid<A>,?>>, MonadRec<Fn1<CompletableFuture<A>,Fn1<CompletableFuture<A>,CompletableFuture<A>>>,Fn1<Monoid<A>,?>>, MonadWriter<Monoid<A>,Fn1<CompletableFuture<A>,Fn1<CompletableFuture<A>,CompletableFuture<A>>>,Fn1<Monoid<A>,?>>

      public final class Compose<A>
      extends Object
      implements MonoidFactory<Monoid<A>,CompletableFuture<A>>

  A `Monoid` instance formed by ``CompletableFuture`<A>` and a monoid over `A`. If either `CompletableFuture`s completes exceptionally, the result is also an exceptionally completed future.

  Note that this operation only takes as long as the slowest future to complete.

  For the `Semigroup`, see `Compose`.

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Monoid<CompletableFuture<A>>` | `checkedApply(Monoid<A> aMonoid)` Invoke this function with the given argument, potentially throwing any `Throwable`.
    `static <A> Compose<A>` | `compose()`
    `static <A> Monoid<CompletableFuture<A>>` | `compose(Monoid<A> aMonoid)`
    `static <A> Fn1<CompletableFuture<A>,CompletableFuture<A>>` | `compose(Monoid<A> aMonoid, CompletableFuture<A> x)`
    `static <A> CompletableFuture<A>` | `compose(Monoid<A> aMonoid, CompletableFuture<A> x, CompletableFuture<A> y)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.specialized.MonoidFactory

      `apply, apply`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.specialized.SemigroupFactory

      `checkedApply`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn3

      `apply, checkedApply, compose, contraMap, diMapL, discardR, flip, fn3, fn3, fn3, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `curried, curry, fn2, fromBiFunction, toBiFunction`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### checkedApply

          public Monoid<CompletableFuture<A>> checkedApply(Monoid<A> aMonoid)

      Description copied from interface: `Fn2`
      Invoke this function with the given argument, potentially throwing any `Throwable`.
      Specified by:
        `checkedApply` in interface `Fn1<Monoid<A>,Fn1<CompletableFuture<A>,Fn1<CompletableFuture<A>,CompletableFuture<A>>>>`
      Specified by:
        `checkedApply` in interface `Fn2<Monoid<A>,CompletableFuture<A>,Fn1<CompletableFuture<A>,CompletableFuture<A>>>`
      Specified by:
        `checkedApply` in interface `MonoidFactory<Monoid<A>,CompletableFuture<A>>`
      Specified by:
        `checkedApply` in interface `SemigroupFactory<Monoid<A>,CompletableFuture<A>>`
      Parameters:
        `aMonoid` - the argument
      Returns:
        the result of the function application

    - #### compose

          public static <A> Compose<A> compose()

    - #### compose

          public static <A> Monoid<CompletableFuture<A>> compose(Monoid<A> aMonoid)

    - #### compose

          public static <A> Fn1<CompletableFuture<A>,CompletableFuture<A>> compose(Monoid<A> aMonoid,
                                                                                   CompletableFuture<A> x)

    - #### compose

          public static <A> CompletableFuture<A> compose(Monoid<A> aMonoid,
                                                         CompletableFuture<A> x,
                                                         CompletableFuture<A> y)